#pragma once
#ifndef _FMC4030_DLL_H_
#define _FMC4030_DLL_H_

#ifdef FMC4030_DLL
#define FMC4030_API  __declspec(dllexport) __stdcall
#else
#define FMC4030_API  __declspec(dllimport) __stdcall
#endif

/* 3޸ģݴҵ³ */
#define MAX_AXIS                     3

/* 豸״̬@machine_status.machineRunStatus */
#define MACHINE_MANUAL                     0x0001     //豸ֶģʽ
#define MACHINE_AUTO                       0x0002     //豸нűģʽ

/* ״̬@machine_status.axisStatus */                      
#define MACHINE_POWER_ON                   0x0000     //
#define MACHINE_RUNNING                    0x0001     //
#define MACHINE_PAUSE                      0x0002     //ͣ
#define MACHINE_RESUME                     0x0004     //
#define MACHINE_STOP                       0x0008     //ֹͣ
#define MACHINE_LIMIT_N                    0x0010     //λ
#define MACHINE_LIMIT_P                    0x0020	  //λ
#define MACHINE_HOME_DONE                  0x0040     //
#define MACHINE_HOME                       0x0080     //
#define MACHINE_AUTO_RUN                   0x0100     //
#define MACHINE_LIMIT_N_NONE               0x0200     //λδ
#define MACHINE_LIMIT_P_NONE               0x0400     //λδ
#define MACHINE_HOME_NONE                  0x0800     //δ
#define MACHINE_HOME_OVERTIME              0x1000     //㳬ʱ

struct machine_status{
	float realPos[MAX_AXIS];                          //ǰʵʱλ
	float realSpeed[MAX_AXIS];                        //ǰʵʱٶ
	unsigned int inputStatus;                         //״̬
	unsigned int outputStatus;                        //״̬
	unsigned int limitNStatus;                        //λ״̬
	unsigned int limitPStatus;                        //λ״̬
	unsigned int machineRunStatus;                    //豸״̬
	unsigned int axisStatus[MAX_AXIS];                //״̬
	unsigned int homeStatus;                          //״̬δʹãͨ״̬ȡ״̬
	char file[20][30];                                //ڳļ20ļ
	//char currentRunFile[30];                          //ǰеļ
	//int currentRunLine;                               //ǰгк
};

struct machine_device_para{
	unsigned int id;
	unsigned int bound232;
	unsigned int bound485;
	char ip[15];
	int port;
	
	int div[MAX_AXIS];
	int lead[MAX_AXIS];
	int softLimitMax[MAX_AXIS];
	int softLimitMin[MAX_AXIS];
	int homeTime[MAX_AXIS];
};

struct machine_version{
	unsigned int firmware;
	unsigned int lib;
	unsigned int serialnumber;
};

#ifdef __cplusplus
extern "C" {
#endif

/* 豸رغ */
int FMC4030_API FMC4030_Open_Device(int id, char* ip, int port);
int FMC4030_API FMC4030_Close_Device(int id);

/* ˶״̬غ */
int FMC4030_API FMC4030_Jog_Single_Axis(int id, int axis, float pos, float speed, float acc, float dec, int mode);
int FMC4030_API FMC4030_Check_Axis_Is_Stop(int id, int axis);
int FMC4030_API FMC4030_Home_Single_Axis(int id, int axis, float homeSpeed, float homeAccDec, float homeFallStep, int homeDir);
int FMC4030_API FMC4030_Stop_Single_Axis(int id, int axis, int mode);
int FMC4030_API FMC4030_Get_Axis_Current_Pos(int id, int axis, float* pos);
int FMC4030_API FMC4030_Get_Axis_Current_Speed(int id, int axis, float* speed);

/* IO */
int FMC4030_API FMC4030_Set_Output(int id, int io, int status);
int FMC4030_API FMC4030_Get_Input(int id, int io, int* status);

/* 485ͨݲ */
int FMC4030_API FMC4030_Write_Data_To_485(int id, char* send, int length);
int FMC4030_API FMC4030_Read_Data_From_485(int id, char* recv, int* length);

/* 485չ豸ڲ˾485չ豸IOչ豸 */
int FMC4030_API FMC4030_Set_FSC_Speed(int id, int slaveId, float speed);

/* ModbusЭFMC4030485߷ModbusЭݷʴӻ豸 */
/* 01룺ȡȦֵ */
int FMC4030_API FMC4030_MB01_Operation(int id, int slaveId, unsigned short int addr, char* recv, int* recvLength);

/* 03룺Ĵֵ */
int FMC4030_API FMC4030_MB03_Operation(int id, int slaveId, unsigned short int addr, int numOfData, char* recv, int* recvLength);

/* 05룺дȦֵ1  0 */
int FMC4030_API FMC4030_MB05_Operation(int id, int slaveId, unsigned short int addr, unsigned short int val, char* recv, int* recvLength);

/* 06룺дĴ0x0000 ~ 0xFFFF */
int FMC4030_API FMC4030_MB06_Operation(int id, int slaveId, unsigned short int addr, unsigned short int val, char* recv, int* recvLength);

/* 16룺дĴ */
int FMC4030_API FMC4030_MB16_Operation(int id, int slaveId, unsigned short int addr, int numOfData, unsigned short int* send, char* recv, int* recvLength);

/* 岹غ */
/** ܣԵǰΪֱ߲岹˶
  * id
  * axis岹ţʮƵĵλʾXYZᣬѡУ0x030x050x06
  * endXյXֵ
  * endYյYֵ
  * speed岹ٶȣٶΪϳٶȣǸʵٶ
  * acc岹ٶȣ˼ٶͬΪϳɼٶ
  * dcc岹ٶȣ˼ٶͬΪϳɼٶ
  */
int FMC4030_API FMC4030_Line_2Axis(int id, unsigned int axis, float endX, float endY, float speed, float acc, float dec);

/** ܣԵǰΪֱ߲岹˶
  * id
  * endXյXֵ
  * endYյYֵ
  * endZյZֵ
  * speed岹ٶȣٶΪϳٶȣǸʵٶ
  * acc岹ٶȣ˼ٶͬΪϳɼٶ
  * dcc岹ٶȣ˼ٶͬΪϳɼٶ
  */
int FMC4030_API FMC4030_Line_3Axis(int id, unsigned int axis, float endX, float endY, float endZ, float speed, float acc, float dec);

/** ܣԵǰΪԲ岹˶
  * id
  * axis岹ţʮƵĵλʾXYZᣬѡУ0x030x050x06
  * endXյXֵ
  * endYյYֵ
  * centerXԲXֵ
  * centerYԲYֵ
  * radiusԲ뾶
  * speed岹ٶȣٶΪϳٶȣǸʵٶ
  * acc岹ٶȣ˼ٶͬΪϳɼٶ
  * dcc岹ٶȣ˼ٶͬΪϳɼٶ
  */
int FMC4030_API FMC4030_Arc_2Axis(int id, unsigned int axis, float endX, float endY, float centerX, float centerY, float radius, float speed, float acc, float dec, int dir);

int FMC4030_API FMC4030_Pause_Run(int id, unsigned int axis);
int FMC4030_API FMC4030_Resume_Run(int id, unsigned int axis);
int FMC4030_API FMC4030_Stop_Run(int id);

/* 豸״̬ѯغ */
/** ܣѯ豸״̬Ϣ
  * id
  * machineDataַָ룬machine_statusĽṹɣɺ齫
  */
int FMC4030_API FMC4030_Get_Machine_Status(int id, unsigned char* machineData);
int FMC4030_API FMC4030_Get_Device_Para(int id, unsigned char* devicePara);
int FMC4030_API FMC4030_Set_Device_Para(int id, unsigned char* devicePara);
int FMC4030_API FMC4030_Get_Version_Info(int id, unsigned char* version);

/* ļغ */
/** ܣؿƿļűļֱΪ.bin  .elo,˺ļϴʱϳʱ
  * id
  * filePathļ·
  * fileTypeļ  1ƿļ  2ƿԶִнűļ
  */
int FMC4030_API FMC4030_Download_File(int id, char* filePath, int fileType);

/* Զغ */
/** ܣƿڵĳԶ
  * id
  * fileļļӿƿڲȡ
  */
int FMC4030_API FMC4030_Start_Auto_Run(int id, char* file);

/** ܣֹͣƿԶ
  * id
  */
int FMC4030_API FMC4030_Stop_Auto_Run(int id);

/** ܣɾڳļ
  * id
  * fileɾļļӿƿڲȡ
  */
int FMC4030_API FMC4030_Delete_Script_File(int id, char* file);


#ifdef __cplusplus
}
#endif 

#endif